/*
 * myListTool.cpp
 *
 *  Created on: Jul 9, 2014
 *      Author: nick
 */
#include <string>
#include <cstdio>

using namespace std;

string prefix = "http://www.staroceans.net";

string header1 =
		"<html><head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><title>My All File List</title>";
string header2 =
		"<meta name=\"GENERATOR\" content=\"Microsoft FrontPage 6.0\"></head>  <body><p><font color=\"#FF0000\">";
string header3 =
		"<font color=\"#FF0000\"><font size=\"7\">All File List</font></p>";

string comment1 =
		"This is a list of all files in this website and to make it easy for searching, the they are sorted by file name"
				" and here is <a href=\"";
string comment2 =
		"/myListTool.html\"> the source code </a> of file how it is generated.";

string tableHeader1 =
		"<table border=\"1\" cellpadding=\"5\" cellspacing=\"5\" width=\"100%\" table-layout=\"fixed\""
				"   <colgroup>"
				"<col span=\"1\" style=\"width: 15%;\">"
				"<col span=\"1\" style=\"width: 70%;\">"
				"<col span=\"1\" style=\"width: 15%;\">"
				"</colgroup>>";
string tableHeader2 =
		"<tr> <th> file index </th>  <th> file name </th>  <th> file path </th> </tr>";
string bottom = "</table></body></html>";

string tableColumn1 = "<tr> <td style=\"width: 5%;\">";
string tableColumn2 = "</td>  <td style=\"width: 20%;\" > <a href=\"";
string tableColumn3 = "\">";
string tableColumn4 = "</a> </td> <td style=\"width: 75%;\">";
string tableColumn5 = "</td></tr>";

string urlEncode(const string& str)
{
	string result;
	for (size_t i = 0; i < str.size(); i++)
	{
		if ((str[i] >= '0' && str[i] <= '9') || (str[i] >= 'A' && str[i] <= 'Z')
				|| (str[i] >= 'a' && str[i] <= 'z'))
		{
			result += str[i];
		}
		else
		{
			const unsigned char MASK1 = 0xF0;
			const unsigned char MASK2 = 0x0F;
			unsigned char ch;

			switch (str[i])
			{
			case '-':
			case '_':
			case '.':
			case '!':
			case '~':
			case '*':
			case '\'':
			case '(':
			case ')':
			case '"':
			case '/':
				result += str[i];
				break;
			default:
				ch = (str[i] & MASK1) >> 4;
				result += '%';

				if (ch > 9)
				{
					ch = ch - 10 + 'A';
				}
				else
				{
					ch = ch + '0';
				}
				result += ch;
				ch = str[i] & MASK2;
				if (ch > 9)
				{
					ch = ch - 10 + 'A';
				}
				else
				{
					ch = ch + '0';
				}
				result += ch;
				break;
			}
		}
	}
	return result;
}


string getFileSizeStr(size_t size)
{
	char buf[64];

	char unit_str = 'B';
	if (size >= 1024)
	{
		// in k
		size = size / 1024;
		unit_str = 'K';
		if (size >= 1024)
		{
			// in M
			size = size / 1024;
			unit_str = 'M';
			if (size >= 1024)
			{
				// in G
				size = size / 1024;
				unit_str = 'G';
			}
		}
	}
	sprintf(buf, "[%lu%c]", (unsigned long) size, unit_str);
	//printf("filename=%s has size of %s\n", p.filename().c_str(), buf);
	return string(buf);
}
